<template>
    <v-card class="pa-2 lista-sem-formatacao" outlined tile>
        <p v-show="false">
            <v-btn :class="{'btn-sucesso' : tiposProdutos.length > 0}" @click="carregaTiposProdutos()">tiposProdutos
            </v-btn>
            <v-btn :class="{'btn-sucesso' : produtos.length > 0}" @click="carregaProdutos()">Produtos</v-btn><br>
        </p>

        <ul v-show="true" v-if="produtos.dados.length > 0">
            <li v-for="tipoProduto in tiposProdutos.dados" :key="tipoProduto.id" @click="openOpcoes(tipoProduto.id)">

                <v-hover v-slot:default="{ hover }">
                    <v-card class="mx-auto" max-width="200">
                        <v-img v-show="tipoProduto.id == 1" class="black--text align-end" height="100px"
                            src="../../assets/hamburger2.png">
                            <v-expand-transition>
                                <div v-if="hover"
                                    class="d-flex transition-fast-in-fast-out yellow darken-2 v-card--reveal display-2 white--text"
                                    style="height: 100%;">
                                    R$5,00
                                </div>
                            </v-expand-transition>
                        </v-img>
                        <v-img v-show="tipoProduto.id == 2" class="black--text align-end" height="100px"
                            src="../../assets/refri.png">
                            <v-expand-transition>
                                <div v-if="hover"
                                    class="d-flex transition-fast-in-fast-out red darken-2 v-card--reveal display-2 white--text"
                                    style="height: 100%;">
                                    R$3,00
                                </div>
                            </v-expand-transition>
                        </v-img>
                        <v-img v-show="tipoProduto.id == 3" class="black--text align-end" height="100px"
                            src="../../assets/alfajor.png">
                            <v-expand-transition>
                                <div v-if="hover"
                                    class="d-flex transition-fast-in-fast-out brown darken-2 v-card--reveal display-2 white--text"
                                    style="height: 100%;">
                                    R$3,00
                                </div>
                            </v-expand-transition>
                        </v-img>
                        <v-img v-show="tipoProduto.id == 4" class="black--text align-end" height="100px"
                            src="../../assets/molho.png">
                            <v-expand-transition>
                                <div v-if="hover"
                                    class="d-flex transition-fast-in-fast-out grey darken-2 v-card--reveal display-2 white--text"
                                    style="height: 100%;">
                                    R$1,00
                                </div>
                            </v-expand-transition>
                        </v-img>

                        <v-expand-transition :key="transitionTipos">
                            <v-card v-show="tipoProduto.id == openOpcao" class="mx-auto">
                                <v-card-text class="text--primary">
                                    <v-select v-model="prodSelect" :items="getItensProdutos(1)"
                                        v-show="tipoProduto.id == 1" label="Selecione" dense outlined></v-select>
                                    <v-select v-model="prodSelect" :items="getItensProdutos(2)"
                                        v-show="tipoProduto.id == 2" label="Selecione" dense outlined></v-select>
                                    <v-select v-model="prodSelect" :items="getItensProdutos(3)"
                                        v-show="tipoProduto.id == 3" label="Selecione" dense outlined></v-select>
                                    <v-select v-model="prodSelect" :items="getItensProdutos(4)"
                                        v-show="tipoProduto.id == 4" label="Selecione" dense outlined></v-select>
                                </v-card-text>
                            </v-card>
                        </v-expand-transition>
                    </v-card>
                </v-hover>
            </li>
        </ul>
    </v-card>
</template>

<script>
    export default {
        name: 'TipoProdutos',
        props: [
            'produtos',
            'tiposProdutos'
        ],
        data() {
            return {
                openOpcao: 0,
                produtoSelecionado: 0,
                produtosValor1: [],
                produtosItens1: [],
                produtosValor2: [],
                produtosItens2: [],
                produtosValor3: [],
                produtosItens3: [],
                produtosValor4: [],
                produtosItens4: [],
                transitionTipos: 0,
                prodSelect: null,
            }
        },
        watch: {
            pedidos: function () {
                console.log("TipoProdutos watch pedidos");
            },
            prodSelect: function () {
                console.log("TipoProdutos watch prodSelect", this.prodSelect);
                this.informaSelecao(this.prodSelect);
            },
        },
        created: async function () {
            console.log("TipoProdutos created");
        },
        mounted: function () { // async function () {
            console.log("TipoProdutos mounted");
            // await this.carregaProdutos();
        },
        methods: {
            getImagemTipoProduto: function (id) {
                console.log("Gerar getImagemTipoProduto", id);
                return this.imagensTipoProdutos[id];
            },
            openOpcoes: function (id) {
                console.log("Gerar OpenOpcoes");
                this.openOpcao = id;
            },
            closeOpcoes: function () {
                console.log("Gerar closeOpcoes");
                this.openOpcao = 0;
            },
            produtosFiltrados: function (tipoProdutoId) {
                console.log("Gerar produtosFiltrados", tipoProdutoId);
                return this.produtos.dados.filter(p => {
                    if (p.tipo_produto_id == tipoProdutoId) return true;
                    else return false;
                });
            },
            carregaProdutos: function () {
                console.log("TipoPedidos carregaProdutos");
                this.$parent.$parent.carregaProdutos();
                setTimeout(function () {}, 0);
                this.transitionTipos++;
            },
            carregaTiposProdutos: function () {
                console.log("TipoProdutos carregaTiposProdutos");
                this.$parent.$parent.carregaTiposProduto();

            },
            getItensProdutos: function (id) {
                // console.log("TipoProdutos getItensProdutos",id);
                let itens = [];

                this.produtos.dados.filter(p => {
                    if (p.tipo_produto_id == id) {
                        itens.push({
                            text: p.nome,
                            value: p.id
                        });
                        return true;
                    } else
                        return false;
                });

                return itens;
            },
            informaSelecao: function (info) {
                console.log("TipoProdutos informaSelecao", info);
                this.$parent.$parent.informaSelecao(info);
            },
        }
    }
</script>

<style lang="scss">
    .btn-sucesso {
        color: green;
    }
</style>